"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reactVirtualized = require("react-virtualized");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _rcCheckbox = _interopRequireDefault(require("rc-checkbox"));

require("./style.css");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Checkboxes =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(Checkboxes, _Component);

  function Checkboxes(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Checkboxes);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(Checkboxes).call(this, props));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleChange", function (record) {
      var optionIndex = _this.state.value.indexOf(record.value);

      var value = (0, _toConsumableArray2.default)(_this.state.value);

      if (optionIndex === -1) {
        value.push(record.value);
      } else {
        value.splice(optionIndex, 1);
      }

      if (!("value" in _this.props)) {
        _this.setState({
          value: value
        });
      }

      var onChange = _this.props.onChange;

      if (onChange) {
        onChange(value);
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "checkboxRenderer", function (_ref) {
      var index = _ref.index,
          style = _ref.style;
      var _this$props = _this.props,
          options = _this$props.options,
          disabled = _this$props.disabled,
          _this$props$prefixCls = _this$props.prefixCls,
          prefixCls = _this$props$prefixCls === void 0 ? "prefixCls" : _this$props$prefixCls;
      var item = options[index];
      return _react.default.createElement("label", {
        key: item.value.toString(),
        style: _objectSpread({}, style, {
          margin: 0
        })
      }, _react.default.createElement(_rcCheckbox.default, {
        prefixCls: prefixCls,
        key: item.value.toString(),
        disabled: disabled,
        value: item.value,
        checked: _this.state.value.indexOf(item.value) !== -1,
        onChange: function onChange() {
          return _this.handleChange(item);
        },
        className: "groupPrefixCls".concat("-item")
      }), item.label);
    });
    _this.state = {
      value: props.value || []
    };
    return _this;
  }

  (0, _createClass2.default)(Checkboxes, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.list.forceUpdateGrid();

      if ("value" in nextProps) {
        var value = nextProps.value;
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          options = _this$props2.options,
          rowHeight = _this$props2.rowHeight,
          height = _this$props2.height,
          width = _this$props2.width;
      var rowCount = options.length;
      return _react.default.createElement(_reactVirtualized.List, {
        style: {
          outline: "none"
        },
        height: height,
        width: width,
        ref: function ref(_ref2) {
          _this2.list = _ref2;
        },
        rowCount: rowCount,
        rowHeight: rowHeight,
        rowRenderer: this.checkboxRenderer
      });
    }
  }]);
  return Checkboxes;
}(_react.Component);

var HeaderBar = function HeaderBar(_ref3) {
  var title = _ref3.title,
      filter = _ref3.filter,
      checkAll = _ref3.checkAll,
      _onChange = _ref3.onChange,
      onCheckAll = _ref3.onCheckAll,
      height = _ref3.height,
      width = _ref3.width,
      disabled = _ref3.disabled,
      headerWrapperClassName = _ref3.headerWrapperClassName;
  return _react.default.createElement("div", {
    style: {
      width: width,
      height: height
    },
    className: (0, _classnames.default)("vcheader__wrapper", headerWrapperClassName)
  }, _react.default.createElement("div", null, _react.default.createElement("label", null, _react.default.createElement(_rcCheckbox.default, {
    prefixCls: "prefixCls",
    className: "vchcheckbox__wrapper",
    checked: checkAll,
    onChange: function onChange(e) {
      return onCheckAll(e.target.checked);
    },
    disabled: disabled
  }), " \u5168\u9009 ".concat(title))), filter && _react.default.createElement("div", {
    className: "vcheader__search"
  }, _react.default.createElement("input", {
    // className="vc__input"
    placeholder: "filter",
    onChange: function onChange(e) {
      return _onChange(e.target.value);
    } // size="small"

  })));
};

var VirtualizedCheckbox =
/*#__PURE__*/
function (_Component2) {
  (0, _inherits2.default)(VirtualizedCheckbox, _Component2);

  function VirtualizedCheckbox(props) {
    var _this3;

    (0, _classCallCheck2.default)(this, VirtualizedCheckbox);
    _this3 = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(VirtualizedCheckbox).call(this, props));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this3), "getFilteredItems", function () {
      var _this3$props = _this3.props,
          options = _this3$props.options,
          filter = _this3$props.filter;
      var filterText = _this3.state.filterText;

      if (!filterText || !filter) {
        return options;
      } else {
        if (typeof filter === "boolean") {
          var results = options.filter(function (it) {
            return it.label && it.label.toLowerCase().indexOf(filterText.toLowerCase()) >= 0;
          });
          return results;
        } else if (typeof filter === "function") {
          return options.filter(function (it) {
            return filter(filterText, it.label);
          });
        }
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this3), "handleCheckAllChange", function (checked) {
      var onChange = _this3.props.onChange;
      var items = checked ? _this3.getFilteredItems().map(function (it) {
        return it.value;
      }) : [];

      _this3.setState({
        checkAll: checked,
        value: items
      });

      if (typeof onChange === "function") onChange(items);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this3), "handleChange", function (value) {
      var onChange = _this3.props.onChange;
      if (typeof onChange === "function") onChange(value);

      _this3.setState({
        value: value
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this3), "handleFilterChange", function (value) {
      _this3.setState(function () {
        return {
          filterText: value
        };
      });
    });
    var _value = props.value,
        defaultValue = props.defaultValue;

    var result = _this3.optimizeOptions();

    _this3.state = {
      value: _value || defaultValue || [],
      options: result,
      filterText: ""
    };
    return _this3;
  }

  (0, _createClass2.default)(VirtualizedCheckbox, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if ("value" in nextProps) {
        var value = nextProps.value;
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "optimizeOptions",
    value: function optimizeOptions() {
      var options = this.props.options;
      return options.map(function (option) {
        if (typeof option === "string") {
          return {
            label: option,
            value: option
          };
        }

        return option;
      });
    }
  }, {
    key: "getRect",
    value: function getRect(h, w) {
      var _height = h || 400;

      var _width = w || 400;

      return {
        height: _height + 16,
        width: _width + 16
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props3 = this.props,
          title = _this$props3.title,
          propHeight = _this$props3.height,
          propWidth = _this$props3.width,
          rowHeight = _this$props3.rowHeight,
          headerHeight = _this$props3.headerHeight,
          disabled = _this$props3.disabled,
          filter = _this$props3.filter,
          headerWrapperClassName = _this$props3.headerWrapperClassName,
          wrapperClassName = _this$props3.wrapperClassName;
      var _this$state = this.state,
          filterText = _this$state.filterText,
          value = _this$state.value;
      var showHeader = filter || title;

      var virtualScrollHeight = function virtualScrollHeight(h) {
        var i = 0;

        if (showHeader) {
          i += 1;
        }

        var actualHeight = h || 400;
        return actualHeight - i * headerHeight;
      };

      var filterOptions = this.getFilteredItems();

      var _terminalWidth = function _terminalWidth(w) {
        return w || 400;
      };

      return _react.default.createElement(_reactVirtualized.AutoSizer, null, function (_ref4) {
        var width = _ref4.width,
            height = _ref4.height;
        return _react.default.createElement("div", {
          style: _this4.getRect(propHeight || height, propWidth || width),
          className: (0, _classnames.default)("virtualized-checkbox", wrapperClassName)
        }, showHeader && _react.default.createElement(HeaderBar, {
          headerWrapperClassName: headerWrapperClassName,
          height: headerHeight,
          width: propWidth || width,
          disabled: disabled,
          title: filterText ? "过滤结果" : title,
          checkAll: filterOptions.length && value.length === filterOptions.length,
          filter: filter,
          onCheckAll: _this4.handleCheckAllChange,
          onChange: _this4.handleFilterChange
        }), _react.default.createElement(Checkboxes, {
          height: virtualScrollHeight(propHeight || height),
          width: _terminalWidth(propWidth || width),
          options: filterOptions,
          rowHeight: rowHeight,
          value: value,
          onChange: _this4.handleChange
        }));
      });
    }
  }]);
  return VirtualizedCheckbox;
}(_react.Component);

(0, _defineProperty2.default)(VirtualizedCheckbox, "propTypes", {
  // 失效状态  boolean default: false
  disabled: _propTypes.default.bool,
  // 搜索框&标题头的高度  number|string default: 34
  headerHeight: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  // 宽高不传入的话，需给定外部容器的宽高
  //高度  number|string default: 400
  height: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  //宽度  number|string default: 400
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  //指定选中的选项	string[]|number[] default: []
  value: _propTypes.default.array,
  //默认选中的选项	string[]|number[] default: []
  defaultValue: _propTypes.default.array,
  //指定可选项	string[] | object[] defalut： []
  options: _propTypes.default.array,
  //变化时回调函数	Function(checkedValue) defalut: -
  onChange: _propTypes.default.func,
  //是否过滤 boolean| Function() default: false
  filter: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.func])
});
(0, _defineProperty2.default)(VirtualizedCheckbox, "defaultProps", {
  disabled: false,
  headerHeight: 34,
  onChange: function onChange() {
    return null;
  },
  rowHeight: 30,
  filter: false
});
var _default = VirtualizedCheckbox;
exports.default = _default;